;
; afli.asm - AFLI IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $fb
p2		= $fd
p3		= $14
spry		= 248

fli		.macro
		lda #\1
		sta $d011
		lda #\2
		sta $d018
		.endm

fli2		.macro
		inc $d011
		lda #\1
		sta $d018
		.endm

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0                
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close           jsr $ffcc
                lda $1
                jmp $ffc3
oerr    	jsr $ffcf
		ldy #0		
                sty $dd
		lda #$40
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<$4000
		ldy #>$4000
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr    	ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		bpl belp

okc		jsr close

		sei
		lda $2a6
		beq okntsc
		lda #$ea
		sta pal1
		sta pal2
		sta pal3
		sta pal4
		sta pal5
		sta pal6
		sta pal7
                inc pal8+1
                inc pal8+1
		sta pal9
		sta pal10
		sta pal11
		sta pal12
		sta pal13
		sta pal14
                lda #$e0
       		sta pal15
                ldx #0
ni              lda pal17,x
                sta pal17-1,x
                inx
                cpx #pal17x-pal17
                bne ni
                lda #$ea
                sta pal17-1,x
                lda #$a9
                inc pal18+1
                inc pal18+1
                sta pal19
                sta pal20
                lda #$24
                sta pal16
okntsc		
		lda #0
		.include "../sprinit.inc"
		lda #255
		ldx #63
o		sta $7fc0,x
		dex
		bpl o
		inx
		txa
oo		sta $8000,x
		sta $8100,x
		inx
		bne oo
		ldx #7
o2		lda #255
		sta $43f8,x
		sta $47f8,x
		sta $4bf8,x
		sta $4ff8,x
		sta $53f8,x
		sta $57f8,x
		sta $5bf8,x
		sta $5ff8,x
		txa
		sta $83f8,x
		dex
		bpl o2
		lda #36
		sta p2
		lda #$80
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$80
		sta p2+1
		jsr print

		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #1
		stx $dd00
		lda #$08
		sta $d018
		dex
                stx $d021
		stx 198
                lda #$78
		sta $d011
		lda #200
		sta $d016
                lda #249
                cmp $d012
                bne *-3
		lda #20
		sta $d012
                lda #$61
		sta $d011
		inc $d019
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3                
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
		stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
		.include "../common.inc"

copy            .text "A"+128,"F"+128,"L"+128,"I"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128

		.page
irq		inc $d019
		lda #25
                sta $d012
                lda #<irqx
                sta $314
		lda #$38
		sta $d011
                cli
                jmp *

irqx		inc $d019
                .endp
		lda #20
                sta $d012
                lda #<irq
                sta $314
                pla
                pla
                pla
                pla
                pla
                pla
		lda #37
		sta $d001
		clc
		adc #42
		sta $d003
		adc #42
		sta $d00b
		adc #42
		sta $d007
		adc #42
		sta $d009
		lda #24
		sta $d000
		sta $d002
		sta $d00a
		sta $d006
		sta $d008
		lda #0
		sta $d027
		sta $d028
         	sta $d02c
		sta $d02a
		sta $d02b
		lda #%00111011
		sta $d017
		lda #2
		sta $dd00
		.page
		ldx #1
		dex
		bne *-1   ;52
pal18           beq *+2
		cmp (0,x)
                nop
                
		lda $d012 ;60
		cmp $d012 ;4
		beq *+2   ;7
		ldx #10   
		dex
		bne *-1   ;58
pal19           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		ldx #10   
		dex
		bne *-1   ;58
pal20           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		lda #47
		cmp $d012
		bne *-3
		ldx #11
		dex
		bne *-1
pal16           cmp (0,x)

		ldx #24
		#fli $38,$18
ff              ldy #$61
		lda #$39
		sta $d011-$61,y
		lda #$28
		sta $d018
		nop
pal1            cmp ($ea,x)
		#fli2 $38
		nop
pal2            cmp ($ea,x)
		#fli2 $48
                nop
pal3            cmp ($ea,x)
		#fli2 $58
		nop
pal4            cmp ($ea,x)
		#fli2 $68
		nop
pal5            cmp ($ea,x)
		#fli2 $78
		nop
pal6            cmp ($ea,x)
		#fli2 $08
		nop
pal7            cmp ($ea,x)
		#fli $38,$18
		dex
pal8		bne ff
		.endp
pal15		clc
		clc
		#fli2 $28
                nop
pal9    	lda ($ea,x)
		#fli2 $38
                nop
pal10   	lda ($ea,x)
		#fli2 $48
                nop
pal11   	lda ($ea,x)
		#fli2 $58
                nop
pal12   	lda ($ea,x)
		#fli2 $68
                nop
pal13   	lda ($ea,x)
		#fli2 $78
                nop
pal14   	lda ($ea,x)
		#fli2 $08
                nop
pal17   	sty $d011
		stx $d017
		sty $dd00
		lda #spry
		sta $d001
		sta $d003
		sta $d007
		sta $d009
		sta $d00b
		lda #88
		sta $d000
		adc #24
		sta $d002
		adc #48
		sta $d006
		adc #24
		sta $d008
		adc #24
		sta $d00a
		sty $d027
		sty $d028
		sty $d02a
		sty $d02b
		sty $d02c
pal17x  	jsr $ea87
		jmp $ea81
dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2

