;
; drl.asm - Drazlace IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1700
p		= $14
p2		= $fb
p3		= $fd
depackide	= $6000
maxdepack	= $a800
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close           jsr $ffcc
                lda #1
                jmp $ffc3
oerr    	jsr $ffcf
		lda #0
		sta $dd
		sta $3f40
		lda #$18
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<$4800
		ldy #>$4800
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		ldx $de
		cpx #$60
		bne belp

okc		jsr close

		sei
		ldx #9
uq		lda $1800,x
		cmp drlind,x
		bne nem
		dex
		bpl uq

		ldx #$0e
		ldy #$18
		lda $180d
		.include "../depack.inc"

		lda #54
		sta $1
		ldx #0
		ldy #32
h1		lda $8800,x
h2		sta $4000,x
		dex
		bne h1
		inc h1+2
		inc h2+2
		dey
		bne h1
		inc $1
		lda $8740
		sta $3f40
		lda $8742
		sta $3f42
		lda #$60
		sta ddd1+2
		lda #$64
		sta ddd3+2
		lda #$68
		sta h3+2
nem
		lda $3f40
		.include "../sprinit.inc"
		ldy #0
		ldx #4
ddd1		lda $1800,y
ddd2		sta $d800,y
ddd3		lda $1c00,y
ddd4		sta $6000,y
ddd5		sta $c000,y
		iny
		bne ddd1
		inc ddd1+2
		inc ddd2+2
		inc ddd3+2
		inc ddd4+2
		inc ddd5+2
		dex
		bne ddd1
		ldx #32
h3		lda $2000,y
h4		sta $e000,y
		iny
		bne h3
		inc h3+2
		inc h4+2
		dex
		bne h3
		tya
nn		sta $6400,y
		sta $6500,y
		iny
		bne nn
		ldy #7
qw		tya
		ora #128+16
		sta $63f8,y
		dey
		bpl qw
		lda #36
		sta p2
		lda #$64
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$64
		sta p2+1
		jsr print

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #0
		sta $dd00
		lda #$08
		sta $d018
		lda $3f40
		sta $d020
		sta $d021
		lda #216
		sta $d016
		lda #249		;50
		sta $d012
		lda #59
		sta $d011
		lda #0
		sta 198
		sta $7fff
		inc $d019
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
drlind		.text "DRAZLACE! "
;---------------------------------------
		.include "../common.inc"

copy 	  	.text "D"+128,"R"+128,"L"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

irq
		lda $d012
		bpl irq2
		ldx #51
		stx $d011
		ldy #14
		dey
		bne *-1
		ldy #$80
		lda #2
		sta $dd00
		sty $d018
		dex
		stx $d012
		lda $d016
		eor $3f42
		and #1
                ora #216
		sta $d016
		inc $d019
		jmp $ea31
irq2		lda #59
		sta $d011
iii		lda #2
		sta $dd00
iii2		ldx #$80
		stx $d018
		eor #2
		sta iii+1
		txa
		eor #$88
		sta iii2+1
		lda #249
		sta $d012
		inc $d019
		jmp $ea81
dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2


