;
; drp.asm - Drazpaint IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $14
p2		= $fb
p3		= $fd
depackide	= $6000
maxdepack	= $8800
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close           jsr $ffcc
                lda #1
                jmp $ffc3
oerr
		jsr $ffcf
		lda #0
		sta $dd
		sta $5f40
		lda #$38
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<$2800
		ldy #>$2800
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		ldx $de
		cpx #$60
		bne belp

okc		jsr close

		sei
		ldx #9
uq		lda $3800,x
		cmp drpind,x
		bne nem
		dex
		bpl uq

		ldx #$0e
		ldy #$38
		lda $380d
		.include "../depack.inc"

		ldx #0
		ldy #$28
h1		lda $6000,x
h2		sta $3800,x
		dex
		bne h1
		inc h1+2
		inc h2+2
		dey
		bne h1
nem
		lda $5f40
		.include "../sprinit.inc"
		ldy #0
		ldx #4
d		lda $3800,y
		sta $d800,y
		lda $3c00,y
		sta $6000,y
		iny
		bne d
		inc d+2
		inc d+5
		inc d+8
		inc d+11
		dex
		bne d
		tya
nn		sta $6400,y
		sta $6500,y
		iny
		bne nn
		ldy #7
qw		tya
		ora #128+16
		sta $63f8,y
		dey
		bpl qw
		lda #36
		sta p2
		lda #$64
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$64
		sta p2+1
		jsr print
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #2
		sta $dd00
		lda #$80
		sta $d018
		lda $5f40
		sta $d020
		sta $d021
		lda #249
		sta $d012
		lda #59
		sta $d011
		lda #216
		sta $d016
		inc $d019
		lda #0
		sta 198
		sta $7fff
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
drpind		.text "DRAZPAINT "
;---------------------------------------
		.include "../common.inc"

copy            .text "D"+128,"R"+128,"P"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

irq		inc $d019
		lda $d012
		bpl irq2
		ldx #51
		stx $d011
		dex
		stx $d012
		jmp $ea31
irq2		lda #59
		sta $d011
		lda #249
		sta $d012
		jmp $ea81
dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2

