;
; hpic.asm - Art Studio 1.1 IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $1f00
p		= $14
p2		= $fb
p3		= $fd
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close		jsr $ffcc
		lda #1
                jmp $ffc3
oerr    	jsr $ffcf

		ldx #0
		lda #$10
iqd		sta $5f40,x
		sta $6040,x
		sta $6140,x
		sta $6240,x
		inx
		bne iqd
		stx $4000+9000

		stx $dd
		lda #$40
		sta $de

		lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<9001
		ldy #>9001
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldy #0
belp		jsr $ffcf
		sta ($dd),y
		bit $90
		bvs okc
		iny
		bne belp
		inc $de
		ldx $de
		cpx #$64
		bne belp

okc		jsr close

		sei
		lda $4000+9000
		.include "../sprinit.inc"
		ldy #7
qw		tya
		ora #128+16
		sta $63f8,y
		dey
		bpl qw
		iny
		tya
nn		sta $6400,y
		sta $6500,y
		iny
		bne nn
		lda #36
		sta p2
		lda #$64
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$64
		sta p2+1
		jsr print

		lda $4000+9000
		pha
		ldx #$e7
		ldy #4
qw1		lda $6240,x
		sta $6300,x
		dex
		cpx #255
		bne qw1
		dec qw1+2
		dec qw1+5
		dey
		bne qw1

		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #2
		sta $dd00
		lda #$80
		sta $d018
		pla
		sta $d020
		sta $d021
		lda #249
		sta $d012
		lda #59
		sta $d011
		lda #200
		sta $d016
		inc $d019
		lda #0
		sta 198
		sta $7fff
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
		bit $d011
		bpl *-3
		bit $d011
		bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts
                
nmi		rti
;---------------------------------------
		.include "../common.inc"

copy            .text "H"+128,"P"+128,"I"+128,"C"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128

irq		inc $d019
		lda $d012
		bpl irq2
		ldx #51
		stx $d011
		dex
		stx $d012
		ldx #10
		dex
		bne *-1
		lda #19
		sta $d011
		jmp $ea31
irq2		lda #59
		sta $d011
		lda #249
		sta $d012
		jmp $ea81
dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2

