;
; shf.asm - Super hires FLI IDE64 manager plugin
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

vic		= $c000
p		= $14
p2		= $fb
p3		= $fd
depackide	= $8000
maxdepack	= $a000
spry		= 251

		.include "../contact.inc"

start		sta db+1
		stx i+1
		sty i+2
		jsr $ffbd
		lda #1
		ldx $ba
		ldy #0
		jsr $ffba
		jsr $ffe7
		jsr $ffc0
		ldx #1
		jsr $ffc6
		jsr $ffcf
                lda $90
                beq oerr
close		jsr $ffcc
		lda #1
                jmp $ffc3
oerr    	jsr $ffcf

		lda #0
		sta $dd
	       	lda #$40
		sta $de

ok      	lda $de60
                cmp #"I"
                bne errr
                lda $de61
                cmp #"D"
                bne errr
                lda $de62
                cmp #"E"
                bne errr
		lda #$dd
		ldx #<16384
		ldy #>16384
		jsr $def4
		bcc okc
                
                ldx #1
                jsr $ffc6

errr		ldx #0
		ldy #0
belp		bit $90
		bvs okc2
		jsr $ffcf
		sta ($dd),y
		iny
		bne belp
		inc $de
		inx
		cpx #$40
		bne belp
okc2		txa
		pha
                tya
                tax
                pla
                tay

okc	        cpx #<15872
		bne b
		cpy #>15872
		bne b
                inc comp+1
b		jsr close
                
        	sei
comp		lda #0
		bne xxxx
		ldx #$01
		ldy #$40
		lda $4000
		.include "../depack.inc"
                ldx #0
                lda #255
nt              sta $4000,x
                inx
                bne nt
                inc nt+2
                bpl nt

                ldx #0
ccc1            lda #0
		sta sprl,x
		lda sprh,x
ccc2            sta $43f8,x
                lsr
                ror sprl,x
                lsr
                ror sprl,x
                ora #$40
                sta sprh,x
                inx
                txa
                and #7
                bne ccc1
                lda ccc2+1
                sec
                sbc #8
                sta ccc2+1
                lda ccc2+2
                adc #3
                sta ccc2+2
                cmp #$63
                bne ccc1

                lda $9fe8
                sta $43e8
                lda $9fe9
                sta $43e9

                lda #<$8000
                sta p
                lda #>$8000
                sta p+1

                ldx #0
rc3     	lda #0
                sta ofs1+1
                sta ofs2+1
rc2             lda sprl,x
ofs1            ora #0
                sta p2
                lda sprh,x
                sta p2+1
                lda sprl+4,x
ofs2            ora #0
                sta p3
                lda sprh+4,x
                sta p3+1
                ldy #2
rc1             lda (p),y
                sta (p2),y
                dey
                bpl rc1
                lda p+1
                ora #$08
                sta p+1
                ldy #2
rc1o            lda (p),y
                sta (p3),y
                dey
                bpl rc1o
                lda p
                sec
                sbc #253
                sta p
                lda p+1
                sbc #7
                sta p+1
                inx
                txa
                and #3
                bne rc2
		txa
                clc
                adc #4
                and #63
                tax
                lda ofs1+1
                clc
                adc #3
                sta ofs1+1
                sta ofs2+1
                cmp #63
                bne rc2
                dec o2+1
o2              lda #8
                bne rc3
                
                lda #<$9000
                sta p
                lda #>$9000
                sta p+1
                lda #<$6071
                sta p2
                lda #>$6071
                sta p2+1
                lda #167
                sta p3

rgc2            ldy #0
                clc
rgc             lda (p),y
                sta (p2,x)
                lda p2
                adc #8
                sta p2
                bcc *+4
                inc p2+1
                iny
                cpy #12
                bcc rgc
                dec p3
                beq rc
                lda p
                adc #11
                sta p
                bcc *+4
                inc p+1
                lda p2
                sec
                sbc #95
                sta p2
                bcs *+4
                dec p2+1
                and #7
                bne rgc2
                lda p2
                clc
                adc #<312
                sta p2
                lda p2+1
                adc #>312
                sta p2+1
                jmp rgc2
                

rc              lda #<$9800
                sta p
                lda #>$9800
                sta p+1
                lda #<$440e
                sta p2
                lda #>$440e
                sta p2+1
                ldx #167
ciu2            ldy #11
ciu             lda (p),y
                sta (p2),y
                dey
                bpl ciu
                lda p
                clc
                adc #12
                sta p
                bcc *+4
                inc p+1
                lda p2+1
                clc
                adc #4
                and #$5f
                sta p2+1
                and #$1c
                bne tni
                lda p2
                clc
                adc #40
                sta p2
                bcc *+4
                inc p2+1
tni             dex
                bne ciu2
xxxx
                lda $2a6
                beq okntsc
                inc pal18+1
                inc pal18+1
                lda #$a9
                sta pal19
                sta pal20
                sta pal1
                sta pal2
okntsc
                lda #15
		.include "../sprinit.inc"
                ldy #0
		tya
nn		sta $8000,y
		sta $8100,y
		iny
		bne nn
		ldy #7
qw		tya
		sta $83f8,y
		dey
		bpl qw
		lda #36
		sta p2
		lda #$80
		sta p2+1
		.include "../nevki.inc"
		lda #0
		sta p2
		lda #$80
		sta p2+1
		jsr print
                
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda #2
		sta $dd00
		lda #$08
		sta $d018
		lda #15
		sta $d020
                sta $d021
		lda #38
		sta $d012
		lda #$3b
		sta $d011
		lda #200
		sta $d016
		inc $d019
		lda #0
		sta 198
                sta $7fff
                sta $bfff
                sta $d07a		;scpu
		cli
		lda 198
		beq *-2
		sei
                sta $d07b
                lda $d011
                bmi *-3
		ldx #$2e
io		lda vic,x
		sta $d000,x
		dex
		bpl io
		lda dd00
		sta $dd00
		lda dd02
		sta $dd02
		lda #43
		sta $d011
		lda #$31
		sta $314
		lda #$ea
		sta $315
		lda onmi
		sta 792
		lda onmi+1
		sta 793
		ldx #1
		stx $dc0e
		dex
		stx $d01a
                stx $d020
		stx 198
		cli
		jsr $e544
		lda $d011
		bpl *-3
		lda $d011
		bmi *-3
		lda vic+$11
		sta $d011
		lda vic+$20
		sta $d020
		rts

nmi		rti
;---------------------------------------
		.include "../common.inc"
                
copy            .text "S"+128,"H"+128,"F"+128," VIEWER1 BY ","S"+128,"OCI/","S"+128,"G"+128,"R"+128," "

	      	*=*+3

		.page
irq		inc $d019
		lda #40
                sta $d012
                lda #<irqx
                sta $314
		lda #$1b
		sta $d011
                cli
                jmp *

irqx		inc $d019
                .endp
		lda #38
                sta $d012
                lda #<irq
                sta $314
                pla
                pla
                pla
                pla
                pla
                pla
ez		lda #2
		sta $dd00
		.page
		ldx #4
		dex
		bne *-1   ;52
pal18           beq *+2
                nop 
                nop

		cmp (0,x)
                
		lda $d012 ;60
		cmp $d012 ;4
		beq *+2   ;7
		ldx #10   
		dex
		bne *-1   ;58
pal19           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
		ldx #10   
		dex
		bne *-1   ;58
pal20           nop       ;60
                nop       
		lda $d012 ;64
		cmp $d012 ;4
		beq *+2   ;7          
                .endp

                lda #136+24*0
                sta $d000
                sta $d008
                lda #136+24*1
                sta $d002
                sta $d00a
                lda #136+24*2
                sta $d004
                sta $d00c
                lda #136+24*3
                sta $d006
                sta $d00e
                ldy #3
k               .page
		lda $43e8
                sta $d027,y
                lda $43e9
                sta $d02b,y
                dey
                bpl k
                .endp
                lda #51
		sta $d001
		sta $d003
		sta $d005
		sta $d007
		sta $d009
		sta $d00b
		sta $d00d
		sta $d00f
		lda #0
                sta $d010
                
                lda #50
                cmp $d012
                bne *-3
                
                ldx #8
                .page
                dex
                bne *-1
                .endp

                nop
                
pal1            clc
                clc
                
pal2            nop
                nop

                lda #$3b
                sta $d011

		cmp (0,x)
                
		jsr shf
		
                lda #249
                cmp $d012
                bne *-3

                lda #255
                sta $d010
                lda #88+24*0
                sta $d000
                lda #88+24*1
                sta $d002
                lda #88+24*2
                sta $d004
                lda #88+24*3
                sta $d006
                lda #88+24*4
                sta $d008
                lda #88+24*5
                sta $d00a
                lda #88+24*6
                sta $d00c
                lda #0
                sta $d027
                sta $d028
                sta $d029
                sta $d02a
                sta $d02b
                sta $d02c
                sta $d02d
                sta $d02e
                sta $d00e
                ldx #128
                stx $d010
                ldy #1

		cmp (0,x)
		nop
		nop

		cmp (0,x)		;ntsc

                ldx #$13
                stx $d011

                sty $dd00

		jmp $ea31

shf     	nop      
		lda #$18
		sta $d018
		inc $d011		;3c

		nop        
		lda #$28
		sta $d018
		inc $d011		;3d

		nop        
		lda #$38
		sta $d018
		inc $d011		;3e

		nop       
		lda #$48
		sta $d018
		inc $d011		;3f

		ldx #$48
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39

		stx $d001
		lda #$78
		sta $d018
		sty $d011		;3a

		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b

		stx $d003
		lda #$18
		sta $d018
		sty $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d005
		lda #$38
		sta $d018
		sty $d011		;3e

		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f

		stx $d007
		lda #$58
		sta $d018
		sty $d011		;38

		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39

		stx $d009
		lda #$78
		sta $d018
		sty $d011		;3a

		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b

		stx $d00b
		lda #$18
		sta $d018
		sty $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d00d
		lda #$38
		sta $d018
		sty $d011		;3e

		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f

		stx $d00f
		lda #$58
		sta $d018
		sty $d011		;38

		nop     
		lda #$68
		sta $d018
		inc $d011		;39

		nop
		lda #$78
		sta $d018
		inc $d011		;3a

		nop
		lda #$08
		sta $d018
		inc $d011		;3b

		nop
		lda #$18
		sta $d018
		inc $d011		;3c

		ldx #$5d
		lda #$28
		sta $d018
		inc $d011		;3d

		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e

		stx $d001
		lda #$48
		sta $d018
		sty $d011		;3f

		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		stx $d003
		lda #$68
		sta $d018
		sty $d011		;39

		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a

		stx $d005
		lda #$08
		sta $d018
		sty $d011		;3b

		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c

		stx $d007
		lda #$28
		sta $d018
		sty $d011		;3d

		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e

		stx $d009
		lda #$48
		sta $d018
		sty $d011		;3f

		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		stx $d00b
		lda #$68
		sta $d018
		sty $d011		;39

		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a

		stx $d00d
		lda #$08
		sta $d018
		sty $d011		;3b

		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c

		stx $d00f
		lda #$28
		sta $d018
		sty $d011		;3d

		nop
		lda #$38
		sta $d018
		inc $d011		;3e

		nop
		lda #$48
		sta $d018
		inc $d011		;3f

		nop
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		nop
		lda #$68
		sta $d018
		inc $d011		;39

		ldx #$72
		lda #$78
		sta $d018
		inc $d011		;3a

		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b

		stx $d001
		lda #$18
		sta $d018
		sty $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d003
		lda #$38
		sta $d018
		sty $d011		;3e

		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f

		stx $d005
		lda #$58
		sta $d018
		sty $d011		;38

		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39

		stx $d007
		lda #$78
		sta $d018
		sty $d011		;3a

		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b

		stx $d009
		lda #$18
		sta $d018
		sty $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d00b
		lda #$38
		sta $d018
		sty $d011		;3e

		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f

		stx $d00d
		lda #$58
		sta $d018
		sty $d011		;38

		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39
                
		stx $d00f
		lda #$78
		sta $d018
		sty $d011		;3a

		nop
		lda #$08
		sta $d018
		inc $d011		;3b

		nop
		lda #$18
		sta $d018
		inc $d011		;3c

		nop
		lda #$28
		sta $d018
		inc $d011		;3d

		nop
		lda #$38
		sta $d018
		inc $d011		;3e

		ldx #$87
		lda #$48
		sta $d018
		inc $d011		;3f

		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		stx $d001
		lda #$68
		sta $d018
		sty $d011		;39

		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a

		stx $d003
		lda #$08
		sta $d018
		sty $d011		;3b

		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c

		stx $d005
		lda #$28
		sta $d018
		sty $d011		;3d

		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e

		stx $d007
		lda #$48
		sta $d018
		sty $d011		;3f

		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		stx $d009
		lda #$68
		sta $d018
		sty $d011		;39

		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a

		stx $d00b
		lda #$08
		sta $d018
		sty $d011		;3b

		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c

		stx $d00d
		lda #$28
		sta $d018
		sty $d011		;3d

		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e

		stx $d00f
		lda #$48
		sta $d018
		sty $d011		;3f

		nop
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38

		nop
		lda #$68
		sta $d018
		inc $d011		;39

		nop
		lda #$78
		sta $d018
		inc $d011		;3a

		nop
		lda #$08
		sta $d018
		inc $d011		;3b

		ldx #$9c
		lda #$18
		sta $d018
		inc $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d001
		lda #$38
		sta $d018
		sty $d011		;3e

		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f

		stx $d003
		lda #$58
		sta $d018
		sty $d011		;38

		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39

		stx $d005
		lda #$78
		sta $d018
		sty $d011		;3a

		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b

		stx $d007
		lda #$18
		sta $d018
		sty $d011		;3c

		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d

		stx $d009
		lda #$38
		sta $d018
		sty $d011		;3e
                
		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f
                
		stx $d00b
		lda #$58
		sta $d018
		sty $d011		;38
                
		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39
                
		stx $d00d
		lda #$78
		sta $d018
		sty $d011		;3a
                
		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b
                
		stx $d00f
		lda #$18
		sta $d018
		sty $d011		;3c
                
		nop
		lda #$28
		sta $d018
		inc $d011		;3d
                
		nop
		lda #$38
		sta $d018
		inc $d011		;3e
                
		nop
		lda #$48
		sta $d018
		inc $d011		;3f
                
		nop
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		ldx #$b1
		lda #$68
		sta $d018
		inc $d011		;39
                
		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a
                
		stx $d001
		lda #$08
		sta $d018
		sty $d011		;3b
                
		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c
                
		stx $d003
		lda #$28
		sta $d018
		sty $d011		;3d
                
		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e
                
		stx $d005
		lda #$48
		sta $d018
		sty $d011		;3f
                
		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		stx $d007
		lda #$68
		sta $d018
		sty $d011		;39
                
		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a
                
		stx $d009
		lda #$08
		sta $d018
		sty $d011		;3b
                
		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c
                
		stx $d00b
		lda #$28
		sta $d018
		sty $d011		;3d
                
		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e
                
		stx $d00d
		lda #$48
		sta $d018
		sty $d011		;3f
                
		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		stx $d00f
		lda #$68
		sta $d018
		sty $d011		;39
                
		nop
		lda #$78
		sta $d018
		inc $d011	  	;3a
                
		nop
		lda #$08
		sta $d018
		inc $d011		;3b
                
		nop
		lda #$18
		sta $d018
		inc $d011		;3c
                
		nop
		lda #$28
		sta $d018
		inc $d011		;3d
                
		ldx #$c6
		lda #$38
		sta $d018
		inc $d011		;3e
                
		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f
                
		stx $d001
		lda #$58
		sta $d018
		sty $d011		;38
                
		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39
                
		stx $d003
		lda #$78
		sta $d018
		sty $d011		;3a
                
		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b
                
		stx $d005
		lda #$18
		sta $d018
		sty $d011	   	;3c
                
		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d
                
		stx $d007
		lda #$38
		sta $d018
		sty $d011		;3e
                
		ldy #$38
		lda #$48
		sta $d018
		inc $d011		;3f
                
		stx $d009
		lda #$58
		sta $d018
		sty $d011		;38
                
		ldy #$3a
		lda #$68
		sta $d018
		inc $d011		;39
                
		stx $d00b
		lda #$78
		sta $d018
		sty $d011		;3a
                
		ldy #$3c
		lda #$08
		sta $d018
		inc $d011		;3b
                
		stx $d00d
		lda #$18
		sta $d018
		sty $d011		;3c
                
		ldy #$3e
		lda #$28
		sta $d018
		inc $d011		;3d
                
		stx $d00f
		lda #$38
		sta $d018
		sty $d011		;3e
                
		nop
		lda #$48
		sta $d018
		inc $d011		;3f
                
		nop
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		nop
		lda #$68
		sta $d018
		inc $d011		;39
                
		nop
		lda #$78
		sta $d018
		inc $d011		;3a
                
		ldx #spry
		lda #$08
		sta $d018
		inc $d011		;3b
                
		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c
                
		stx $d001
		lda #$28
		sta $d018
		sty $d011		;3d
                
		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e
                
		stx $d003
		lda #$48
		sta $d018
		sty $d011		;3f
                
		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		stx $d005
		lda #$68
		sta $d018
		sty $d011		;39
                
		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a
                
		stx $d007
		lda #$08
		sta $d018
		sty $d011		;3b
                
		ldy #$3d
		lda #$18
		sta $d018
		inc $d011		;3c
                
		stx $d009
		lda #$28
		sta $d018
		sty $d011		;3d
                
		ldy #$3f
		lda #$38
		sta $d018
		inc $d011		;3e
                
		stx $d00b
		lda #$48
		sta $d018
		sty $d011		;3f
                
		ldy #$39
		lda #$58
		sta $d018
		lda #$38
		sta $d011		;38
                
		stx $d00d
		lda #$68
		sta $d018
		sty $d011		;39
                
		ldy #$3b
		lda #$78
		sta $d018
		inc $d011		;3a
                
		stx $d00f
		lda #$08
		sta $d018
		sty $d011		;3b
		rts

sprh   		.byte $80
		.byte $84
		.byte $85
		.byte $89
		.byte $8a
		.byte $8e
		.byte $8f
		.byte $93

		.byte $94
		.byte $98
		.byte $99
		.byte $9d
		.byte $9e
		.byte $a2
		.byte $a3
		.byte $a7

		.byte $a8
		.byte $ac
		.byte $ad
		.byte $b1
		.byte $b2
		.byte $b6
		.byte $b7
		.byte $bb

		.byte $bc
		.byte $c0
		.byte $c1
		.byte $c5
		.byte $c6
		.byte $ca
		.byte $cb
		.byte $cf

		.byte $d0
		.byte $d4
		.byte $d5
		.byte $d9
		.byte $da
		.byte $de
		.byte $df
		.byte $e3

		.byte $e4
		.byte $e8
		.byte $e9
		.byte $ea
		.byte $eb
		.byte $ec
		.byte $ed
		.byte $ee

		.byte $ef
		.byte $f0
		.byte $f1
		.byte $f2
		.byte $f3
		.byte $f4
		.byte $f5
		.byte $f6

		.byte $f7
		.byte $1e
		.byte $2e
		.byte $3e
		.byte $4e
		.byte $5e
		.byte $6e
		.byte $7e

sprl    	*=*+64

dd00
		*= *+1
dd02
		*= *+1
onmi
		*= *+2
;comp
;		*= *+1

;		*= $3ffe
                
;                .binary crest1.shf

